// Created by trevor on 2/19/17.

declare class IClientUserModel {
	passwordHashed: boolean;

	LoginModel()

	constructor(user, userFactory: IUserFactory)

	hashPassword()

	toJson()

	getBland()
}

declare class IUserModel {
	_id: string;
	username: string;
	password: string;
	first_name: string;
	last_name: string;
	email: string;
	role: string;
}

declare class IUserFactory {
	user;
	token: string;
	LoggedIn: boolean;

	constructor(bcrypt, $http, $rootScope);

	Initialize();

	getSelectList(resolve: (list: any[]) => void, reject: (error: string) => void);

	getOneById(id: string, resolve: (list: any) => void, reject: (error: string) => void);

	StoreCredentials(user: IUserModel, token: string);

	ClearCredentials();

	LoadCredentials();

	setUser(user: IUserModel): IUserModel;

	httpServerCall(url: string, method: string, data: any, success: (any) => void, failure?: (any) => void);

	ChangePassword(pswd: string, newPassword: string, success: () => void, failure?: (message: string) => void);

	HashString(toHash: string): string;

	$get();

}

declare module 'web-angularjs-user-factory' {
	export let UserFactory: IUserFactory;
	export let UserModel: IUserFactory;
	export let ClientUserModel: IClientUserModel;
	export let UserFactoryModule: IUserFactory;
	export let ClientSalt: string;
}